;;; PLAETTEN.LSP
;;; Programm zum ndern aller Z-Koordinatenwerte 
;;; Version 1.0 vom November 2001
;;; Programmiert von Martin Drese
;;; www.cadwiesel.de
(defun C:PLAETTEN (/ M:SS1         M:SS1LEN      i           M:NUMCHG
                     M:ENAME       M:ELIST       M:ETYPE       M:TXT
                     M:WRT         M:TEMP_LAENGE M:TEMP_LISTE  M:ROTOR
                     M:LINE      M:TEXT      M:MTEXT     M:MD_ERR
                     M:CIRCLE    M:ARC       M:POINT     M:FEHLER
                     M:SHAPE     M:ELLIPSE   M:DIM       M:MLINE
                     M:LWPOLYLINE            M:POLYLINE  M:LEADER
                     M:HATCH     M:INSERT    M:INBLK     M:BEARB_LIST M:XLINE M:SPLINE M:TRACE M:SOLID M:IMAGE M:BTAB M:BLK M:INDEX
                     ) ;_ end of /
 ;_ end of /
  (setq M:MD_ERR  *ERROR*
        *ERROR* M:FEHLER
        ) ;_ end of setq
  ;;Marke fr Zurck nach Abbruch setzen
  (command "_.UNDO" "_MARK")
  (setvar "cmdecho" 0)
  (setvar "tilemode" 1)
  (command "_view" "_top"
           "_ucs" "_W")
  
  (command "_.-Layer" "_unlock" "*" "")
  (prompt
    "\nElemente whlen zum Pltten, oder Return fr alle... "
    ) ;_ end of prompt
  (setq M:SS1 (ssget))
  (if (null M:SS1)                        ;if enter, ZOOM All and choose everything
    (setq
      M:SS1 (ssget "X" '((-4 . "<NOT") (0 . "VIEWPORT") (-4 . "NOT>")))
      ) ;_ end of setq
    )                                   ;if
                                        ;*initialize variables
  (setq M:SS1LEN       (sslength M:SS1)     ;length of selection set
        i            0                  ;loop counter
        M:NUMCHG       0                  ;number changed counter
        M:LINE       0
        M:XLINE      0
        M:TEXT       0
        M:MTEXT      0
        M:CIRCLE     0
        M:ARC        0
        M:POINT      0
        M:SHAPE      0
        M:ELLIPSE    0
        M:DIM        0
        M:MLINE      0
        M:LWPOLYLINE 0
        M:POLYLINE   0
        M:SPLINE     0
        M:LEADER     0
        M:HATCH      0
        M:INSERT     0
        M:INBLK      0
        M:3DFACE     0
        M:TRACE      0
        M:SOLID      0
        M:IMAGE      0
        M:BEARB_LIST nil
        )                               ;setq
                                        ;*do the work
  (prompt "\n  Arbeite.")
  (terpri)
  (while (< i M:SS1LEN)                   ;while more members in the SS
    (cond
      (M:ROTOR
       (setq M:ROTOR NIL)
       (princ (strcat (itoa M:NUMCHG) "\r \\ "))
       )
      (t
       (setq M:ROTOR
              (princ (strcat (itoa M:NUMCHG) "\r / "))
             ) ;_ end of setq
       )
      ) ;_ end of cond
    (setq M:ENAME (ssname M:SS1 i)          ;entity name
          M:ELIST (entget M:ENAME)          ;entity data list
          M:ETYPE (cdr (assoc 0 M:ELIST))   ;entity type
          NOTYP (cdr (assoc 100 M:ELIST))
          )                             ;setq
                                        ;*change group 10 Z coordinate to 0 for listed entity types
    (cond
      ((member M:ETYPE
               '("LINE" "XLINE" "TEXT" "MTEXT" "CIRCLE" "ARC" "POINT" "SHAPE"
                 "ELLIPSE")
               ) ;_ end of member
       (setq M:ELIST  (zeroz 10 M:ELIST)    ;change entities in list above
             M:NUMCHG (1+ M:NUMCHG)
             )                          ;setq
       (cond
         ((= M:ETYPE "LINE") (setq M:LINE (1+ M:LINE)))
         ((= M:ETYPE "XLINE") (setq M:XLINE (1+ M:XLINE)))
         ((= M:ETYPE "TEXT") (setq M:TEXT (1+ M:TEXT)))
         ((= M:ETYPE "MTEXT") (setq M:MTEXT (1+ M:MTEXT)))
         ((= M:ETYPE "CIRCLE") (setq M:CIRCLE (1+ M:CIRCLE)))
         ((= M:ETYPE "ARC") (setq M:ARC (1+ M:ARC)))
         ((= M:ETYPE "POINT") (setq M:POINT (1+ M:POINT)))
         ((= M:ETYPE "SHAPE") (setq M:SHAPE (1+ M:SHAPE)))
         ((= M:ETYPE "ELLIPSE") (setq M:ELLIPSE (1+ M:ELLIPSE)))
         ) ;_ end of cond
       )
                                        ;*change group 10 Z coordinate to 0 for POLYLINES
      ((member M:ETYPE '("DIMENSION" "IMAGE"))
       (setq M:ELIST  (zeroz 10 M:ELIST)    ;change entities in list above
             M:ELIST  (zeroz 11 M:ELIST)    ;change entities in list above
             M:ELIST  (zeroz 13 M:ELIST)    ;change entities in list above
             M:ELIST  (zeroz 14 M:ELIST)    ;change entities in list above
             M:NUMCHG (1+ M:NUMCHG)
             )                          ;setq
       (cond
         ((= M:ETYPE "DIMENSION") (setq M:DIM (1+ M:DIM)))
         ((= M:ETYPE "IMAGE") (setq M:IMAGE (1+ M:IMAGE)))
         )
       )
      ((member M:ETYPE '("MLINE" "SPLINE" "3DFACE" "TRACE" "SOLID"))
       (setq M:ELIST   (lw_list 10 M:ELIST) ;change entities in list above
             M:ELIST   (lw_list 11 M:ELIST) ;change entities in list above
             M:ELIST   (lw_list 12 M:ELIST) ;change entities in list above
             M:ELIST   (lw_list 13 M:ELIST) ;change entities in list above
             M:NUMCHG  (1+ M:NUMCHG)
             )                          ;setq
       (cond
         ((= M:ETYPE "MLINE") (setq M:MLINE (1+ M:MLINE)))
         ((= M:ETYPE "SPLINE") (setq M:SPLINE (1+ M:SPLINE)))
         ((= M:ETYPE "3DFACE") (setq M:3DFACE (1+ M:3DFACE)))
         ((= M:ETYPE "TRACE") (setq M:TRACE (1+ M:TRACE)))
         ((= M:ETYPE "SOLID") (setq M:SOLID (1+ M:SOLID)))
         ) ;_ end of cond
       )
      ((member M:ETYPE
               '("LWPOLYLINE" "LEADER" "HATCH")
               ) ;_ end of member
       (setq M:ELIST (lw_list 10 M:ELIST)  ;change entities in list above
             M:ELIST (lw_OB_hoe 38 M:ELIST)
             M:ELIST (lw_OB_hoe 39 M:ELIST)
             M:NUMCHG (1+ M:NUMCHG)
             )                          ;setq
       (cond
         ((= M:ETYPE "LWPOLYLINE")
          (setq M:LWPOLYLINE (1+ M:LWPOLYLINE))
          )
         ((= M:ETYPE "LEADER") (setq M:LEADER (1+ M:LEADER)))
         ((= M:ETYPE "HATCH") (setq M:HATCH (1+ M:HATCH)))
         ) ;_ end of cond
       )
      ((= M:ETYPE "POLYLINE")
       (setq M:ELIST      (pl_list 10 M:ELIST)
                                        ;change entities in list above
             M:NUMCHG     (1+ M:NUMCHG)
             M:POLYLINE (1+ M:POLYLINE)
             )                          ;setq
       )
      ((= M:ETYPE "INSERT")
       (setq ;AUSRICHT (cdr (assoc 210 M:ELIST))
             M:ELIST     (zeroz 10 M:ELIST) ;change entities in list above
             M:NUMCHG    (1+ M:NUMCHG)
             M:INSERT  (1+ M:INSERT)
             M:BTAB (tblsearch "BLOCK" (cdr (assoc 2 M:ELIST)))
             M:INDEX     0
             M:BLK (cdr (assoc -2 M:BTAB))
             )                          ;setq

       (while M:BLK
         (cond
           (M:ROTOR (setq M:ROTOR NIL) (princ "\r \\ "))
           (t (setq M:ROTOR (princ "\r / ")))
           ) ;_ end of cond
         (setq M:ELIST (entget M:BLK)
               M:ETYPE (cdr (assoc 0 M:ELIST))
               ) ;_ end of setq
         (cond
           ((member M:ETYPE
                    '("ATTDEF" "LINE"  "XLINE" "TEXT"    "CIRCLE"
                      "ARC"    "POINT" "SHAPE" "ELLIPSE"
                      )
                    ) ;_ end of member
            (setq M:ELIST (zeroz 10 M:ELIST)
;;;           ;change entities in list above
                  M:INBLK (1+ M:INBLK)
                  )                     ;setq
            )
         ((member M:ETYPE '("DIMENSION" "IMAGE"))
           (setq M:ELIST   (zeroz 10 M:ELIST)
                                        ;change entities in list above
                 M:ELIST   (zeroz 11 M:ELIST)
                                        ;change entities in list above
                 M:ELIST   (zeroz 13 M:ELIST)
                                        ;change entities in list above
                 M:ELIST   (zeroz 14 M:ELIST)
                                        ;change entities in list above
                 M:INBLK (1+ M:INBLK)
                 )                      ;setq
           )
           ((member M:ETYPE '("MLINE" "SPLINE" "3DFACE" "TRACE" "SOLID"))
            (setq M:ELIST (lw_list 10 M:ELIST)
                                        ;change entities in list above
                  M:ELIST (lw_list 11 M:ELIST)
                                        ;change entities in list above
                  M:ELIST (lw_list 12 M:ELIST)
                                        ;change entities in list above
                  M:ELIST (lw_list 13 M:ELIST)
                                        ;change entities in list above
                  M:INBLK (1+ M:INBLK)
                  )                     ;setq
            )
                                        ;*change group 10 Z coordinate to 0 for POLYLINES
           ((= M:ETYPE "POLYLINE")
            (setq M:ELIST (pl_list 10 M:ELIST)
                                        ;change entities in list above
                  M:INBLK (1+ M:INBLK)
                  )                     ;setq
            )
                                        ;*change group 10 Z coordinate to 0 for LWPOLYLINES
           ((member M:ETYPE
               '("LWPOLYLINE" "LEADER" "HATCH")
               ) ;_ end of member
            (setq M:ELIST (lw_list 10 M:ELIST)
                  M:ELIST (lw_OB_hoe 38 M:ELIST)
                  M:ELIST (lw_OB_hoe 39 M:ELIST)
                                        ;change entities in list above
                  M:INBLK (1+ M:INBLK)
                  )                     ;setq
            )
           )                            ;ende cond
                                        ;*change group 11 Z coordinate to 0 for LINEs and TEXT
         (if (or (= M:ETYPE "LINE") (= M:ETYPE "XLINE") (= M:ETYPE "ATTDEF") (= M:ETYPE "TEXT"))
           (setq M:ELIST (zeroz 11 M:ELIST))
           )                            ;if
                                        ;(md_objhoe)
         (if M:ELIST(entmod M:ELIST))
         (setq M:BLK (entnext M:BLK))
         )                              ;ende while
       )                                ;ende insert
      (T
       (if (null M:TEMP_LISTE)
         (setq M:TEMP_LISTE '()) ;_ end setq
         ) ;_ end if
       (if (= (member M:ETYPE M:TEMP_LISTE) NIL)
         (setq M:TEMP_LISTE (append (list M:ETYPE) M:TEMP_LISTE))
         ) ;_ end if
       )
      )                                 ;ende cond
                                        ;*change group 11 Z coordinate to 0 for LINEs and TEXT
    (if (or (= M:ETYPE "LINE") (= M:ETYPE "XLINE") (= M:ETYPE "TEXT"))
      (setq M:ELIST (zeroz 11 M:ELIST))
      )                                 ;if

    (setq i (1+ i))                     ;next entity
    )                                   ;while

  (setq M:BEARB_LIST
         (strcat  "\n" (itoa M:NUMCHG) " von " (itoa M:SS1LEN) " Elementen bearbeitet"
                  "\nFolgende Objektklassen wurden bearbeitet:\n"
                 "\nLinien:		"
                 (itoa M:LINE)
                 "\nXLinien:		"
                 (itoa M:XLINE)
                 "\nPolylinien:		"
                 (itoa M:POLYLINE)
                 "\nLWPolylinien:	"
                 (itoa M:LWPOLYLINE)
                 "\nMultilinien:	"
                 (itoa M:MLINE)
                 "\nSplines:		"
                 (itoa M:SPLINE)
                 "\nTexte:		"
                 (itoa M:TEXT)
                 "\nMtexte:		"
                 (itoa M:MTEXT)
                 "\nBlcke:		"
                 (itoa M:INSERT) "  Elemente in Blcken:  " (itoa M:INBLK)
                 "\nKreise:		"
                 (itoa M:CIRCLE)
                 "\nBgen:		"
                 (itoa M:ARC)
                 "\nPunkte:		"
                 (itoa M:POINT)
                 "\nShapes:		"
                 (itoa M:SHAPE)
                 "\nElipsen:		"
                 (itoa M:ELLIPSE)
                 "\nBemassungen:	"
                 (itoa M:DIM)
                 "\nFhrungslinien:	"
                 (itoa M:LEADER)
                 "\nSchraffuren:	"
                 (itoa M:HATCH)
                 "\n3D Flchen:	"
                 (itoa M:3DFACE)
                 "\nBnder:		"
                 (itoa M:TRACE)
                 "\nSolids:		"
                 (itoa M:SOLID)
                 "\nBilder:		"
                 (itoa M:IMAGE)
                 ) ;_ end of strcat
        ) ;_ end of setq
  (alert M:BEARB_LIST)

  (setq M:TEMP_LAENGE (length M:TEMP_LISTE))
  (repeat M:TEMP_LAENGE
    (setq M:WRT        (car M:TEMP_LISTE)
          M:TEMP_LISTE (cdr M:TEMP_LISTE)
          ) ;_ end setq
    (if (null M:TXT)
      (setq M:TXT "Folgende Objektklassen wurden NICHT bearbeitet:\n")
      ) ;_ end if
    (setq M:TXT (strcat M:TXT M:WRT "\n"))
    ) ;_ end repeat
  (if M:TXT
    (alert M:TXT)
    ) ;_ end if

  (md_objhoe)
  (setq *ERROR* M:MD_ERR)
  (command "_.regenall")
  (princ)

  )  ;defun

(prompt "\nProgramm zum Verndern aller Z-Koordinaten auf 0.\nAufruf des Programms mit: \"PLAETTEN\" !")
(princ) ;_ Fngt das nil vom prompt ab

 (defun M:FEHLER (MSG)
    (command "_.UNDO" "_BACK")
    (setq *ERROR* M:MD_ERR)
    (princ
      (strcat "Fehler! AutoCAD meldet: \"" MSG "\" als Ursache.")
      ) ;_ end of princ
    (princ)
    ) ;_ end of defun

(defun zeroz (M:KEY M:ZELIST / M:OPLIST M:NPLIST)
  (setq M:OPLIST (assoc M:KEY M:ZELIST)
        M:NPLIST (cons M:KEY (trans (cdr (reverse (append '(0.0) (cdr (reverse M:OPLIST)))))1 0 T))
        M:ZELIST (subst M:NPLIST M:OPLIST M:ZELIST)
        )                               ;setq
  (entmod M:ZELIST)
  )                                     ;defun

(defun lw_list (M:KEY M:ZELIST / M:OPLIST M:NPLIST X)
  (mapcar
    '(lambda (x)
       (if (= (car x) M:KEY)
         (progn
           (setq M:OPLIST X
                 M:NPLIST (append
                          (list M:KEY)
                          (trans
                          (reverse
                            (append
                              '(0.0)
                              (reverse (list (nth 1 M:OPLIST) (nth 2 M:OPLIST)))
                              ) ;_ end of append
                            )           ;reverse
                          1 0 T)
                          ) ;_ end of append
                 M:ZELIST (subst M:NPLIST M:OPLIST M:ZELIST)
                 )                      ;setq
           ;(entmod M:ZELIST)
           )                            ;ende progn
         x
         )                              ;ende if
       )                                ;ende lambda
    M:ZELIST
    )                                   ;ende mapcar
  (entmod M:ZELIST)
  )                                     ;ende defun

(defun lw_OB_hoe (M:KEY M:ZELIST / M:OPLIST M:NPLIST X)
  (mapcar
    '(lambda (x)
       (if (= (car x) M:KEY)
         (progn
           (setq M:OPLIST X
                 M:NPLIST (cons M:KEY '0.0)
                 M:ZELIST (subst M:NPLIST M:OPLIST M:ZELIST)
                 )                      ;setq
           )                            ;ende progn
         x
         )                              ;ende if
       )                                ;ende lambda
    M:ZELIST
    )                                   ;ende mapcar
  (entmod M:ZELIST)
  )                                     ;ende defun



(defun pl_list (M:KEY M:ZELIST / M:OPLIST M:NPLIST M:ELISTORG)
  (setq M:ELISTORG (entget (cdr (assoc -1 M:ZELIST))))
  (setq M:ZELIST (entget (entnext (cdr (assoc -1 M:ZELIST)))))
  (mapcar
    '(lambda (x)
       (if (not (and (= (car x) 100)
                     (or (= (cdr x) "AcDbPolygonMesh")
                         (= (cdr x) "AcDbPolygonMeshVertex")
                         ) ;_ end of or
                     ) ;_ end of and
                ) ;_ end of not
         (progn
           (while (/= (cdr (assoc 0 M:ZELIST)) "SEQEND")
             (setq M:OPLIST (assoc M:KEY M:ZELIST)
                   M:NPLIST (cons M:KEY (trans (cdr (reverse (append '(0.0) (cdr (reverse M:OPLIST)))))1 0 T));(reverse (append '(0.0) (cdr (reverse M:OPLIST))))
                   M:ZELIST (subst M:NPLIST M:OPLIST M:ZELIST)
                   )                    ;setq
             (entmod M:ZELIST)
             (setq M:ZELIST (entget (entnext (cdr (assoc -1 M:ZELIST)))))
             )                          ;ende while
           )                            ;progn
         x
         )                              ;if
       )                                ;lambda
    M:ZELIST
    )                                   ;mapcar
  (entmod M:ELISTORG)
  )                                     ;ende defun

(defun md_objhoe (/ M:MDAS1)
  (if (setq M:MDAS1 (ssget "X"
                          '((-4 . "<OR")
                            (-4 . "/=")
                            (39 . 0)
                            (-4 . "/=")
                            (38 . 0)
                            (-4 . "OR>")
                            )
                          ) ;_ end of ssget
            ) ;_ end of setq
    (command "_.change"  M:MDAS1 "" "_properties" "_t" "0" "_elevation" "0" "")
    )                                   ;ende if
  )                                     ;ende defun

(princ)
;|Visual LISP Format Options
(72 2 40 1 T "end of " 60 9 0 0 0 nil T nil T)
;*** KEINEN Text unterhalb des Kommentars hinzufgen! ***|;
